package com.yunzhi.niucai.alipay;

import com.alibaba.fastjson.JSONObject;
import com.alipay.api.AlipayApiException;
import com.alipay.api.AlipayClient;
import com.alipay.api.DefaultAlipayClient;
import com.alipay.api.request.AlipayOpenAuthTokenAppRequest;
import com.alipay.api.response.AlipayOpenAuthTokenAppResponse;
import com.yunzhi.niucai.entity.TaAlipay;
import com.yunzhi.niucai.service.ITaAlipayService;
import com.yunzhi.niucai.service.ITaShopAppService;
import org.springframework.beans.factory.InitializingBean;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.Map;

@Component
public class AlipayFactory implements InitializingBean {
    private AlipayClient alipayClient;

    @Resource(name = "taShopAppServiceImpl")
    private ITokenResolve tokenResolve;

    @Autowired
    private Config config;

    @Autowired
    ITaShopAppService iTaShopAppService;

    @Autowired
    ITaAlipayService iTaAlipayService;

    public PayService getService(Integer shopId) {
        return new PayService(shopId, alipayClient, tokenResolve, config);
    }

    private AlipayClient getAlipayClient(Config config) {
        return new DefaultAlipayClient(config.getApiURL(),
                config.getAppid(),
                config.getPrivateKey(),
                config.getFormat(),
                config.getCharset(),
                config.getPublicKey(),
                config.getSignType());
    }

    @Override
    public void afterPropertiesSet() throws Exception {
        // 写死, 取第一个
        TaAlipay taAlipay = iTaAlipayService.getById(1);
        this.config.setAppid(taAlipay.getAppid())
                .setPrivateKey(taAlipay.getMerchantPrivateKey())
                .setPublicKey(taAlipay.getAlipayPublicKey());

        //
        this.alipayClient = getAlipayClient(this.config);
    }
}
