package com.yunzhi.niucai.alipay;

public interface ITokenResolve {

    /**
     * Token 是否过期
     * @param shopId
     * @return
     */
    boolean isTokenExpired(Integer shopId);

    /**
     * 获取 Token
     * @param shopId
     * @return
     */
    String getAuthToken(Integer shopId);

    /**
     * 获取 refreshToken
     * @param shopId
     * @return
     */
    String getRefreshToken(Integer shopId);

    /**
     * 持久化 Token
     * @param appId
     * @param alipayId
     * @param authToken
     * @param refreshToken
     * @param expiresIn
     */
    void persistAuthToken(String appId, String alipayId, String authToken, String refreshToken, String expiresIn);

    /**
     * 刷新 Token
     * @param shopId
     * @return
     */
    void refreshAuthToken(Integer shopId, String authToken, String refreshToken, String expiresIn);
}
